#pragma once

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartPrint  C++(EVC++, Visual Studio 2005, 2008 ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartPrintWrap.h SmartPrintWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// www.hnsts.co.kr
// SmartX copyright(c)2002 All rights reserved by HNS Corp.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef bool (*PrintSetupEx)(LPTSTR strPrinterID, int iQuality, int iColorMode, int iPaperSize, int iOrientation, int iCopies);
typedef void (*NewPageEx)();
typedef void (*PrintOutEx)();
typedef int (*IsPrintingEx)();
typedef void (*GetPaperPixelEx)(int* iWidthPixel, int* iHeightPixel);

typedef void  (*EraseEx)();
typedef void  (*SetPixelsEx)(int iXPos, int iYPos, int crColor);
typedef void  (*LineEx)(int ifx, int ify, int isx, int isy);
typedef void  (*PolylinesEx)(POINT* pPoint, int iNum);
typedef void  (*PolygonsEx)(POINT* pPoint, int iNum);
typedef void  (*RectanglesEx)(int iLeftX, int iTopY, int iWidth, int iHeight);
typedef void  (*RoundRect1Ex)(int iLeftX, int iTopY, int iWidth, int iHeight, int iRWidth, int iRHeight);
typedef void  (*RoundRect2Ex)(int iLeftX, int iTopY, int iWidth, int iHeight, int iRadius);
typedef void  (*CircleEx)(int iCenX, int iCenY, int iDiameter);
typedef void  (*EllipsesEx)(int iCenX, int iCenY, int iWidth, int iHeight);
typedef void  (*GradientFillsEx)(int iLeftX, int iTopY, int iWidth, int iHeight, int startColor, int endColor, int dwMode);
typedef void  (*TextOutEx)(int iXpos, int iYpos, LPTSTR strFormat);
typedef void  (*ImageDraw1Ex)(int iResourceID, int iXpos, int iYpos, int iWidth, int iHeight);
typedef void  (*ImageDraw2Ex)(int iResourceID, int iXpos, int iYpos);
typedef void  (*ImageDraw3Ex)(LPCTSTR strFilePath, int iXpos, int iYpos, int iWidth, int iHeight);
typedef void  (*ImageDraw4Ex)(LPCTSTR  strFilePath, int iXpos, int iYpos);
typedef void  (*SetBrushStyleEx)(int brushColor, bool bTransparent);
typedef void  (*SetPenStyleEx)(int penColor, int iWidth);
typedef void  (*SetFontCfg1Ex)(LPTSTR strFontName, int iFontSize, int cFontColor, bool bBold, bool bItalic, bool bAntiAlased);
typedef void  (*SetFontCfg2Ex)(LPTSTR strFontName, int iFontSize, int cFontColor);
typedef void  (*SetFontCfg3Ex)(int iFontSize, int cFontColor);
typedef void  (*DisplayToPrint1Ex)(int iXpos, int iYpos, int iWidth, int iHeight);
typedef void  (*DisplayToPrint2Ex)(int iXpos, int iYpos);
typedef void  (*SethInstanceEx)(HINSTANCE hInstance);

class CSmartPrintWrap
{
private:
	HINSTANCE		m_hInst;
	
	PrintSetupEx	m_pfPrintSetup;
	
	NewPageEx		m_pfNewPage;
	PrintOutEx		m_pfPrintOut;
	IsPrintingEx	m_pfIsPrinting;
	GetPaperPixelEx	m_pfGetPaperPixel;

	EraseEx			m_pfErase;
	SetPixelsEx		m_pfSetPixels;
	LineEx			m_pfLine;
	PolylinesEx		m_pfPolylines;
	PolygonsEx		m_pfPolygons;
	RectanglesEx	m_pfRectangles;
	RoundRect1Ex	m_pfRoundRect1;
	RoundRect2Ex	m_pfRoundRect2;
	CircleEx		m_pfCircle;
	EllipsesEx		m_pfEllipses;
	GradientFillsEx	m_pfGradientFills;
	TextOutEx		m_pfTextOut;
	ImageDraw1Ex	m_pfImageDraw1;
	ImageDraw2Ex	m_pfImageDraw2;
	ImageDraw3Ex	m_pfImageDraw3;
	ImageDraw4Ex	m_pfImageDraw4;
	SetBrushStyleEx	m_pfSetBrushStyle;
	SetPenStyleEx	m_pfSetPenStyle;
	SetFontCfg1Ex	m_pfSetFontCfg1;
	SetFontCfg2Ex	m_pfSetFontCfg2;
	SetFontCfg3Ex	m_pfSetFontCfg3;

	DisplayToPrint1Ex m_pfDisplayToPrint1;
	DisplayToPrint2Ex m_pfDisplayToPrint2;

	SethInstanceEx	m_pfSethInstance;
	
public:
	CSmartPrintWrap(void);
	~CSmartPrintWrap(void);
	
	bool PrintSetup(LPTSTR strPrinterID, int iQuality, int iColorMode, int iPaperSize, int iOrientation, int iCopies);
	void NewPage();
	void PrintOut();
	int IsPrinting();
	void GetPaperPixel(int* iWidthPixel, int* iHeightPixel);

	void Erase();
	void SetPixel(int iXPos, int iYPos, int crColor);
	void Line(int ifx, int ify, int isx, int isy);
	void Polyline(POINT* pPoint, int iNum);
	void Polygon(POINT* pPoint, int iNum);
	void Rectangle(int iLeftX, int iTopY, int iWidth, int iHeight);
	void RoundRect(int iLeftX, int iTopY, int iWidth, int iHeight, int iRWidth, int iRHeight);
	void RoundRect(int iLeftX, int iTopY, int iWidth, int iHeight, int iRadius);
	void Circle(int iCenX, int iCenY, int iDiameter);
	void Ellipse(int iCenX, int iCenY, int iWidth, int iHeight);
	void GradientFill(int iLeftX, int iTopY, int iWidth, int iHeight, int startColor, int endColor, int dwMode);
	void TextOut(int iXpos, int iYpos, LPTSTR strFormat, ...);
	void ImageDraw(int iResourceID, int iXpos, int iYpos, int iWidth, int iHeight);
	void ImageDraw(int iResourceID, int iXpos, int iYpos);
	void ImageDraw(LPCTSTR strFilePath, int iXpos, int iYpos, int iWidth, int iHeight);
	void ImageDraw(LPCTSTR  strFilePath, int iXpos, int iYpos);
	void SetBrushStyle(int brushColor, bool bTransparent = true);
	void SetPenStyle(int penColor, int iWidth);
	void SetFontCfg(LPTSTR strFontName, int iFontSize, int cFontColor, bool bBold, bool bItalic, bool bAntiAlased);
	void SetFontCfg(int iFontSize, int cFontColor);
	void SetFontCfg(LPTSTR strFontName, int iFontSize, int cFontColor);
	void DisplayToPrint(int iXpos, int iYpos, int iWidth, int iHeight);
	void DisplayToPrint(int iXpos, int iYpos);
	
	void SethInstance(HINSTANCE hInstance);
};
