#pragma once

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Class SmartVideo  C++(EVC++, Visual Studio 2005, 2008) ϵ Wrapping ClassԴϴ.
//  Class ϱ ؼ SmartVideoCoreWrap.h SmartVideoCoreWrap.cpp  Ʈ Ͽ Ͻñ ٶϴ.
//    Ե "DLL\SmartVideoCoreDll.dll" Ǵ ϰ   Ͽ Ͻñ ٶϴ.
//  
// ڼ  SmartX ޴  Ͻñ ٶϴ.
//
// SmartX copyright(c)2008 All rights reserved by HNS Corp.   www.hnsts.co.kr
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef bool (*InitializationEx)(int iPreviewResolution);
typedef void (*SetPreviewWindowHandleEx)(HWND hPreviewWindow);
typedef bool (*PlayEx)();
typedef bool (*StopEx)();
typedef bool (*SetPreviewResolutionEx)(int iPreviewResolution);
typedef void (*GetPreviewResolutionEx)(int* pWidth, int* pHeight);
typedef bool (*SetCaptureResolutionEx)(int iCaptureResolution);
typedef void (*GetCaptureResolutionEx)(int* pWidth, int* pHeight);
typedef bool (*ImageMemoryCaptureEx)(unsigned char* pRawByte);
typedef bool (*CaptureStillImageEx)(LPTSTR strImgPathName);
typedef void (*SetEncodingParameter1Ex)(LPTSTR strOutFilePathName, unsigned int iframe_rate, unsigned int ibitrate);
typedef void (*SetEncodingParameter2Ex)(unsigned int igop_num, unsigned int iIntraqp, unsigned int iqpmax, float fgamma);
typedef bool (*InitEncodingEx)();
typedef bool (*RunEncodingEx)();
typedef bool (*EndEncodingEx)();
typedef bool (*StopEncodingEx)();
typedef void (*SetSourceChannelEx)(int iChannel);
typedef void (*SetBrightnessControlEx)(int iBrightness);
typedef void (*SetHueControlEx)(int iHue);
typedef void (*SetContrastControlEx)(int iContrast);
typedef void (*SetColorSaturationControlEx)(int iColorSaturation);
typedef void (*SetDefaultControlEx)();


class CSmartVideoCoreWrap
{
private:
	HINSTANCE					m_hInst;

	InitializationEx			m_pfInitialization;
	SetPreviewWindowHandleEx	m_pfSetPreviewWindowHandle;
	PlayEx						m_pfPlay;
	StopEx						m_pfStop;
	SetPreviewResolutionEx		m_pfSetPreviewResolution;
	GetPreviewResolutionEx		m_pfGetPreviewResolution;
	SetCaptureResolutionEx		m_pfSetCaptureResolution;
	GetCaptureResolutionEx		m_pfGetCaptureResolution;
	ImageMemoryCaptureEx		m_pfImageMemoryCapture;
	CaptureStillImageEx			m_pfCaptureStillImage;
	SetEncodingParameter1Ex		m_pfSetEncodingParameter1;
	SetEncodingParameter2Ex		m_pfSetEncodingParameter2;
	InitEncodingEx				m_pfInitEncoding;
	RunEncodingEx				m_pfRunEncoding;
	EndEncodingEx				m_pfEndEncoding;
	StopEncodingEx				m_pfStopEncoding;
	SetSourceChannelEx			m_pfSetSourceChannel;
	SetBrightnessControlEx		m_pfSetBrightnessControl;
	SetHueControlEx				m_pfSetHueControl;
	SetContrastControlEx		m_pfSetContrastControl;
	SetColorSaturationControlEx m_pfSetColorSaturationControl;
	SetDefaultControlEx			m_pfSetDefaultControl;

public:
	CSmartVideoCoreWrap(void);
	virtual ~CSmartVideoCoreWrap(void);

	bool Initialization(int iPreviewResolution);
	void SetPreviewWindowHandle(HWND hPreviewWindow);
	bool Play();
	bool Stop();
	bool SetPreviewResolution(int iPreviewResolution);
	void GetPreviewResolution(int* pWidth, int* pHeight);
	bool SetCaptureResolution(int iCaptureResolution);
	void GetCaptureResolution(int* pWidth, int* pHeight);
	bool ImageMemoryCapture(unsigned char* pRawByte);
	bool CaptureStillImage(LPTSTR strImgPathName);
	void SetEncodingParameter1(LPTSTR strOutFilePathName, unsigned int iframe_rate, unsigned int ibitrate);
	void SetEncodingParameter2(unsigned int igop_num, unsigned int iIntraqp, unsigned int iqpmax, float fgamma);
	bool InitEncoding();
	bool RunEncoding();
	bool EndEncoding();
	bool StopEncoding();
	void SetSourceChannel(int iChannel);
	void SetBrightnessControl(int iBrightness);
	void SetHueControl(int iHue);
	void SetContrastControl(int iContrast);
	void SetColorSaturationControl(int iColorSaturation);
	void SetDefaultControl();
};
